﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Stack {
  using System.Collections;
  using System.Collections.Generic;

  public interface IPushStack : IEnumerable {
    bool IsEmpty { get; }
    bool IsEnabled { get; }
    int Count { get; }

    void Clear();
    void Swap(int count);
    void Yank(int index);
    void RemoveTop();
    void Remove(int count);
    void RemoveAt(int index);
    void RemoveAt(int index, int count);
    IEnumerable<string> AsStrings();
    IEnumerable<object> AsObjects();
  }
}
